# StateMachine.TransitionType (ARX Developer Documentation)

org.deidentifier.arx.framework.check

## Enum StateMachine.TransitionType

- java.lang.Object
- - java.lang.Enum<StateMachine.TransitionType>
  - - org.deidentifier.arx.framework.check.StateMachine.TransitionType

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<StateMachine.TransitionType>
  Enclosing class:
    StateMachine

      public static enum StateMachine.TransitionType
      extends java.lang.Enum<StateMachine.TransitionType>

  The possible transition type.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `ROLLUP` Apply the roll-up optimization.
    `SNAPSHOT` Apply the snapshot optimization.
    `UNOPTIMIZED` Unfortunately all rows need to be transformed.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static StateMachine.TransitionType` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static StateMachine.TransitionType[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### ROLLUP

          public static final StateMachine.TransitionType ROLLUP

      Apply the roll-up optimization.

    - #### SNAPSHOT

          public static final StateMachine.TransitionType SNAPSHOT

      Apply the snapshot optimization.

    - #### UNOPTIMIZED

          public static final StateMachine.TransitionType UNOPTIMIZED

      Unfortunately all rows need to be transformed.

  - ### Method Detail

    - #### values

          public static StateMachine.TransitionType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (StateMachine.TransitionType c : StateMachine.TransitionType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static StateMachine.TransitionType valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null